;******************************************************************************
;CHBT.lsp
;Benoetigt: CHBT.dcl
;Suchen/Ersetzen von Textstellen in Masstexten und Texten.
;(C) Copyright Konstruktionsbuero W. MEYER, D-85649 OTTERLOH,        20.04.2001
;******************************************************************************
(defun c:CHBT (/ ent orgtext dcl_id sset sslen ostr oslen  nstr 
                 si stemp st elnt elns elntox elnto elnso)

 (command "_UNDO" "_m")(terpri)(terpri)

 (defun *error* (msg)
  (setq ent nil orgtext nil dcl_id nil sset nil sslen nil ostr nil oslen nil
        nstr nil si nil stemp nil st nil elnt nil elns nil elntox nil elnto nil
        elnso nil
  )
  (princ msg)(princ)
 )
 (setvar "cmdecho" 0)
;------------------------------------------------------------------------------
 (setq ent (car (entsel "\nWhle zur Vorgabe einen Masstext oder Text. ")))
 (if (= "DIMENSION" (cdr (assoc 0 (entget ent))))
  (FINDorgtext)
  (setq orgtext (cdr (assoc 1 (entget ent))))
 )
 (setq dcl_id (load_dialog "CHBT.DCL"))
 (if (not (new_dialog "CHBTEDIT" dcl_id)) (exit) )
;Keyfestlegungen-----------------------------------
;Vorgaben------------------------------------------
 (set_tile "ALTZF" orgtext)
 (set_tile "NEUZF" orgtext)
;Ausfhrungen--------------------------------------
 (action_tile "ALTZF"  "(setq ostr $value)")
 (action_tile "NEUZF"  "(setq nstr $value)")
 (action_tile "cancel" "(EXIT)")
 (action_tile "accept" "(done_dialog)")
 (start_dialog)
 (unload_dialog dcl_id)
 (princ "\nWhle alle zu ndernden Texte und Masstexte. ")
 (setq sset (ssget (list (cons -4 "<or")
                         (cons  0 "TEXT")
                         (cons  0 "MTEXT")
                         (cons  0 "DIMENSION")
                         (cons -4 "or>")
 )          )      )
 (setq sslen (sslength sset))
 (while (>= (setq sslen (1- sslen)) 0 )
  (setq ent (ssname sset sslen))
  (entmod (entget ent))
  (setq ent  (entget ent))
  (setq oslen (strlen ostr))
  (setq nslen (strlen nstr))
  (setq si 1)
  (if (= "DIMENSION" (cdr (assoc 0 ent)))
   (FINDstemp)  
   (setq stemp (cdr (assoc 1 ent)))
  )
  (while (= oslen (strlen (setq st (substr stemp si oslen))))
   (if (= st ostr)
    (progn
     (setq stemp (strcat
                   (if (> si 1) (substr stemp 1 (1- si)) "" )
                   nstr (substr stemp (+ si oslen))
     )            )
     (setq si (+ si nslen))
    )
    (setq si (1+ si))
   )
  )
  (entmod (subst (cons 1 stemp) (assoc 1 ent) ent))
 )
 (princ)
)
;*****************************************************************************
(defun FINDstemp (/ elnt elns)
 (if (= "DIMENSION" (cdr (assoc 0 ent)))
  (progn
   (setq elnt (tblsearch "BLOCK" (cdr (assoc 2 ent))))
   (setq elns (cdr (assoc -2 elnt)))
   (while elns
    (setq elnt (entget elns))
    (if (= "MTEXT" (cdr (assoc 0 elnt)))
     (setq stemp (cdr (assoc 1 elnt)) elns nil stemp (substr stemp 5))
     (setq elns (entnext elns))
    )
   )
  )
 )
 (princ)
)
;******************************************************************************
(defun FINDorgtext (/ elntox elnto elnso)
 (entmod (entget ent))
 (setq elntox  (entget ent))
 (if (= "DIMENSION" (cdr (assoc 0 elntox)))
  (progn
   (setq elnto (tblsearch "BLOCK" (cdr (assoc 2 elntox))))
   (setq elnso (cdr (assoc -2 elnto)))
   (while elnso
    (setq elnto (entget elnso))
    (if (= "MTEXT" (cdr (assoc 0 elnto)))
     (setq orgtext (cdr (assoc 1 elnto)) elnso nil orgtext (substr orgtext 5))
     (setq elnso (entnext elnso))
    )
   )
  )
 )
 (princ)
)
;******************************************************************************
(princ "\nSuchen/Ersetzen von Textstellen in Masstexten und Texten.  Start mit: CHBT ")
(princ)